package com.github.itzilly.sbt

import net.minecraft.client.settings.KeyBinding
import net.minecraftforge.fml.client.registry.ClientRegistry
import org.lwjgl.input.Keyboard

object STBKeyBinds {
    lateinit var addWaypoint: KeyBinding
    lateinit var finishWaypoints: KeyBinding
    lateinit var clearWaypoints: KeyBinding
    lateinit var openRoutesGui: KeyBinding
    lateinit var xrayChests: KeyBinding

    lateinit var xOffsetIncrease: KeyBinding
    lateinit var xOffsetDecrease: KeyBinding
    lateinit var zOffsetIncrease: KeyBinding
    lateinit var zOffsetDecrease: KeyBinding
    lateinit var showOffset: KeyBinding

    fun init() {
        addWaypoint = KeyBinding("key.addWaypoint", Keyboard.KEY_ADD, "key.categories.sbt")
        ClientRegistry.registerKeyBinding(addWaypoint)

        finishWaypoints = KeyBinding("key.finishWaypoints", Keyboard.KEY_P, "key.categories.sbt")
        ClientRegistry.registerKeyBinding(finishWaypoints)

        clearWaypoints = KeyBinding("key.clearWaypoints", Keyboard.KEY_MINUS, "key.categories.sbt")
        ClientRegistry.registerKeyBinding(clearWaypoints)

        openRoutesGui = KeyBinding("key.openRoutesGui", Keyboard.KEY_O, "key.categories.sbt")
        ClientRegistry.registerKeyBinding(openRoutesGui)

        xrayChests = KeyBinding("key.xrayToggle", Keyboard.KEY_I, "key.categories.sbt")
        ClientRegistry.registerKeyBinding(xrayChests)

        xOffsetIncrease = KeyBinding("key.xOffsetIncrease", Keyboard.KEY_RIGHT, "key.categories.sbt")
//        ClientRegistry.registerKeyBinding(xOffsetIncrease)

        xOffsetDecrease = KeyBinding("key.xOffsetDecrease", Keyboard.KEY_LEFT, "key.categories.sbt")
//        ClientRegistry.registerKeyBinding(xOffsetDecrease)

        zOffsetIncrease = KeyBinding("key.zOffsetIncrease", Keyboard.KEY_UP, "key.categories.sbt")
//        ClientRegistry.registerKeyBinding(zOffsetIncrease)

        zOffsetDecrease = KeyBinding("key.zOffsetDecrease", Keyboard.KEY_DOWN, "key.categories.sbt")
//        ClientRegistry.registerKeyBinding(zOffsetDecrease)

        showOffset = KeyBinding("key.showOffset", Keyboard.KEY_INSERT, "key.categories.sbt")
//        ClientRegistry.registerKeyBinding(showOffset)
    }
}