package com.github.itzilly.sbt.features.mining.routeMaker

import com.github.itzilly.sbt.features.mining.routeMaker.RouteMaker.markerList
import net.minecraft.client.Minecraft
import net.minecraft.client.gui.GuiButton
import net.minecraft.client.gui.GuiScreen
import net.minecraft.client.gui.GuiTextField
import net.minecraft.client.renderer.GlStateManager
import java.awt.Color


class RouteMarkerButton(buttonId: Int, x: Int, y: Int, widthIn: Int, heightIn: Int, buttonText: String?) :
    GuiButton(buttonId, x, y, widthIn, heightIn, buttonText) {
    constructor(buttonId: Int, x: Int, y: Int, buttonText: String?) : this(buttonId, x, y, 200, 20, buttonText)

    override fun drawButton(mc: Minecraft, mouseX: Int, mouseY: Int) {
        if (visible) {
            val fontrenderer = mc.fontRendererObj
            //mc.getTextureManager().bindTexture(buttonTextures);
            GlStateManager.color(1.0f, 1.0f, 1.0f, 1.0f)
            hovered =
                mouseX >= xPosition && mouseY >= yPosition && mouseX < xPosition + width && mouseY < yPosition + height
            //int i = this.getHoverState(this.hovered);
            drawRect(
                xPosition, yPosition, xPosition + width, yPosition + height,
                if (hovered) Color(255, 255, 255, 80).rgb else Color(0, 0, 0, 80).rgb
            )
            //this.drawTexturedModalRect(this.xPosition, this.yPosition, 0, 46 + i * 20, this.width / 2, this.height);
            //this.drawTexturedModalRect(this.xPosition + this.width / 2, this.yPosition, 200 - this.width / 2, 46 + i * 20, this.width / 2, this.height);
            mouseDragged(mc, mouseX, mouseY)
            var j = 14737632
            if (packedFGColour != 0) {
                j = packedFGColour
            } else if (!enabled) {
                j = 10526880
            } else if (hovered) {
                j = 16777120
            }
            drawCenteredString(
                fontrenderer,
                displayString, xPosition + width / 2, yPosition + (height - 8) / 2, j
            )
        }
    }
}

class RouteGui : GuiScreen() {
    private val id: Int = 0

    override fun initGui() {
        super.initGui()
        buttonList.clear()

        populateRouteList()
        buttonList.add(RouteMarkerButton(9000, width / 2 + 20, height - 40, "Exit"))
    }

    override fun actionPerformed(button: GuiButton?) {
        if (button == null) {
            return
        }
        if (button.id < 1000) {
            buttonList.remove(button)
        } else if (button.id == 9000) {
            Minecraft.getMinecraft().thePlayer.closeScreen()
        }
    }

    override fun drawScreen(mouseX: Int, mouseY: Int, partialTicks: Float) {
        this.drawDefaultBackground()
        super.drawScreen(mouseX, mouseY, partialTicks)
    }

    private fun populateRouteList() {
        for ((buttonId, m: RouteMarker) in markerList.withIndex()) {
            val markerField = GuiTextField(1000 + buttonId, fontRendererObj, width / 2 - 200, 0, 100, 20)
            markerField.text = "${m.options.name} X:${m.x} Y:${m.y} Z:${m.z}"
            val removeButton = RouteMarkerButton(2000 + buttonId, width / 2 + 175, 0, 50, 20, "Remove")
            buttonList.add(removeButton)
        }
    }

}