package com.github.itzilly.sbt

import com.github.itzilly.sbt.renderer.RenderUtils
import net.minecraft.client.Minecraft
import net.minecraft.client.renderer.GlStateManager
import net.minecraft.util.AxisAlignedBB
import net.minecraft.util.ChatComponentText
import net.minecraftforge.client.event.RenderWorldLastEvent
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent
import net.minecraftforge.fml.common.gameevent.InputEvent
import org.lwjgl.opengl.GL11
import kotlin.math.round

object MyCrap {
    var xOffset: Double = 0.0
    var zOffset: Double = 0.0

    @SubscribeEvent
    fun onKeyInput(event: InputEvent.KeyInputEvent) {
        if (STBKeyBinds.xOffsetIncrease.isPressed) {
            xOffset += 0.5
            Minecraft.getMinecraft().thePlayer.addChatMessage(ChatComponentText("X Offset: $xOffset"))
        }

        if (STBKeyBinds.xOffsetDecrease.isPressed) {
            xOffset -= 0.5
            Minecraft.getMinecraft().thePlayer.addChatMessage(ChatComponentText("X Offset: $xOffset"))
        }

        if (STBKeyBinds.zOffsetIncrease.isPressed) {
            zOffset += 0.5
            Minecraft.getMinecraft().thePlayer.addChatMessage(ChatComponentText("Y Offset: $zOffset"))
        }

        if (STBKeyBinds.zOffsetDecrease.isPressed) {
            zOffset -= 0.5
            Minecraft.getMinecraft().thePlayer.addChatMessage(ChatComponentText("Y Offset: $zOffset"))
        }

        if (STBKeyBinds.showOffset.isPressed) {
            Minecraft.getMinecraft().thePlayer.addChatMessage(ChatComponentText("X Offset: $xOffset"))
            Minecraft.getMinecraft().thePlayer.addChatMessage(ChatComponentText("Y Offset: $zOffset"))
        }


    }

    @SubscribeEvent
    fun highlightBlockToAdd(event: RenderWorldLastEvent) {
        val mc = Minecraft.getMinecraft()
        val player = mc.thePlayer
        val partialTicks = event.partialTicks

        // Get the rounded block position
        val x = round(mc.thePlayer.posX - 0.5).toInt()
        val y = round(mc.thePlayer.posY).toInt()
        val z = round(mc.thePlayer.posZ - 0.5).toInt()

        val padding = 0.0020000000949949026

        // Interpolate entity position for smooth rendering
        val entityX = player.lastTickPosX + (player.posX - player.lastTickPosX) * partialTicks
        val entityY = player.lastTickPosY + (player.posY - player.lastTickPosY) * partialTicks
        val entityZ = player.lastTickPosZ + (player.posZ - player.lastTickPosZ) * partialTicks

        val outlineStartColor = 0xFFFFFF
        val outlineEndColor = 0xFFFFFF

        // Create a default bounding box for the air block
        val boundingBox = AxisAlignedBB(
            x.toDouble(), y.toDouble(), z.toDouble(),
            x + 1.0, y + 1.0, z + 1.0
        ).expand(padding, padding, padding)

        GL11.glPushMatrix()
        GlStateManager.disableTexture2D()
        GlStateManager.depthMask(false)
        GlStateManager.disableDepth()
        GL11.glEnable(GL11.GL_LINE_SMOOTH)
        GL11.glHint(GL11.GL_LINE_SMOOTH_HINT, GL11.GL_NICEST)
        GL11.glLineWidth(2.0f)
        GL11.glShadeModel(GL11.GL_SMOOTH)

        // Draw the block with the specified colors
        RenderUtils.drawBlock(boundingBox.offset(-entityX, -entityY, -entityZ), outlineStartColor, outlineEndColor)

        GL11.glLineWidth(2.0f)
        GL11.glDisable(GL11.GL_LINE_SMOOTH)
        GlStateManager.enableDepth()
        GlStateManager.depthMask(true)
        GlStateManager.enableAlpha()
        GlStateManager.enableTexture2D()
        GL11.glPopMatrix()
    }
}